package door

// Need net, flag for setupSockets
import (
	"testing"
)

func TestFIFOEmpty(t *testing.T) {
	buffer := NewFIFOBuffer(3)

	defer func() {
		if r := recover(); r == nil {
			t.Error("Pop of empty FIFO Buffer did not panic.")
		}
	}()

	buffer.Push(1)
	x := buffer.Pop()
	if x != 1 {
		t.Errorf("Buffer did not return expected value 1: %d", x)
	}

	_ = buffer.Pop()
}

func TestFIFOOverflow(t *testing.T) {
	buffer := NewFIFOBuffer(3)

	defer func() {
		if r := recover(); r == nil {
			t.Error("Pop of empty FIFO Buffer did not panic.")
		}
	}()

	buffer.Push(1)
	buffer.Push(2)
	buffer.Push(3)
	buffer.Push(4)

}
